Index: /trunk/gli/src/org/greenstone/gatherer/cdm/PlugInManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/PlugInManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/PlugInManager.java	(revision 4932)
@@ -733,9 +624,15 @@
 	    move_up.setMnemonic(KeyEvent.VK_U);
 	    movement_pane = new JPanel();
-	    plugin = new JComboBox(available);
-	    //plugin.setEditable(true);
+
+	    plugin = new GComboBox(getAvailable());
+	    plugin.setBackgroundNonSelectionColor(Gatherer.config.getColor("coloring.editable", false));
+	    plugin.setBackgroundSelectionColor(Gatherer.config.getColor("coloring.collection_selection_background", false));
+	    plugin.setEditable(true);
 	    plugin.setSelectedIndex(0);
+	    plugin.setTextNonSelectionColor(Gatherer.config.getColor("coloring.workspace_tree_foreground", false));
+	    plugin.setTextSelectionColor(Gatherer.config.getColor("coloring.collection_selection_foreground", false));
+
 	    plugin_label = new JLabel(get("PlugIn"));
-	    plugin_list = new JList(assigned);
+	    plugin_list = new JList(model);
 	    plugin_list.setCellRenderer(new ListRenderer());
 	    plugin_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
@@ -822,13 +719,8 @@
 	public void destroy() {
 	}
-	/** This method is overridden in some control classes to allow for the updating of collection configuration when the focus is lost to another view. In this case however the updates are asynchronous and so no 'has the configuration changed without the user updating' check is needed.
-			* @return <i>true</i> if this control has focus, <i>false</i> otherwise.
-			*/
-	public boolean hasFocus() {
-	    return super.hasFocus();
-	}
+
 	/** This method is overridden to ensure the instructions are scrolled to top, before the super classes updateUI() is called.
-			*/
-	public void updateUI() {
+	 */
+	public void gainFocus() {
 	    if(instructions != null) {
 		instructions.setCaretPosition(0);
@@ -836,93 +728,95 @@
 	    super.updateUI();
 	}
-	/** This class listens for actions upon the add button in the controls, and if detected calls the <i>assignPlugIn()</i> method.
-			*/
+
+	public void loseFocus() {
+
+	}
+
+	/** This class listens for actions upon the add button in the controls, and if detected calls the <i>assignPlugIn()</i> method. */
 	private class AddListener
 	    implements ActionListener {
-				/** Any implementation of <i>ActionListener</i> must include this method so that we can be informed when an action has occured on one of our target controls.
-				 * @param event An <strong>ActionEvent</strong> containing information garnered from the control action.
-				 */
+	    /** Any implementation of <i>ActionListener</i> must include this method so that we can be informed when an action has occured on one of our target controls.
+	     * @param event An <strong>ActionEvent</strong> containing information garnered from the control action.
+	     */
 	    public void actionPerformed(ActionEvent event) {
-		PlugIn new_plugin = null;
-		Object object = plugin.getSelectedItem();
-		if(object instanceof PlugIn) {
-		    PlugIn target = (PlugIn)object;
-		    new_plugin = target.copy();
-		}
-		else {
-		    new_plugin = new PlugIn(object.toString(), "", null);
-		}
-		object = null;
-		// Automatically chain to configuration. This ensures required arguments are filled out.
-		ArgumentConfiguration ac = new ArgumentConfiguration(gatherer, manager, new_plugin);
-		if(ac.display()) {
-		    assignPlugIn(new_plugin);
-		    plugin_list.setSelectedValue(new_plugin, true);
-		}
-		ac = null;
-		new_plugin = null;
-		plugin.setSelectedIndex(0);
-	    }
-	}
-	/** This class listens for actions upon the configure button in the controls, and if detected creates a new <strong>ArgumentConfiguration</strong> dialog box to allow for configuration.
-			* @see org.greenstone.gatherer.cdm.ArgumentConfiguration
-			*/
-	private class ConfigureListener
-	    implements ActionListener {
-				/** Any implementation of <i>ActionListener</i> must include this method so that we can be informed when an action has occured on one of our target controls.
-				 * @param event An <strong>ActionEvent</strong> containing information garnered from the control action.
-				 */
-	    public void actionPerformed(ActionEvent event) {
-		if(!plugin_list.isSelectionEmpty()) {
-		    Object object = plugin_list.getSelectedValue();
-		    if(object instanceof PlugIn) {
-			ArgumentConfiguration ac = new ArgumentConfiguration(gatherer, manager, (PlugIn)object);
+		Object selected_object = plugin.getSelectedItem();
+		// If there is something in the combobox, but we haven't registered a selection, then add the object and select it!
+		if(selected_object != null && plugin.getSelectedIndex() == -1) {
+		    plugin.insertItemAt(selected_object, plugin.getItemCount());
+		}
+		if(selected_object != null) {
+		    // Create a new element in the DOM
+		    Element element = CollectionDesignManager.collect_config.document.createElement(CollectionConfiguration.PLUGIN_ELEMENT);
+		    // Remember that the plugin supplied might be a custom string rather than a base plugin
+		    PlugIn new_plugin = null;
+		    if(selected_object instanceof PlugIn) {
+			PlugIn base_plugin = (PlugIn) selected_object;
+			element.setAttribute(CollectionConfiguration.TYPE_ATTRIBUTE, base_plugin.getName());
+			new_plugin = new PlugIn(element, base_plugin);
+			base_plugin = null;
+		    }
+		    else {
+			element.setAttribute(CollectionConfiguration.TYPE_ATTRIBUTE, selected_object.toString());
+			new_plugin = new PlugIn(element, null);
+		    }
+		    if(!model.contains(new_plugin)) {
+			// Automatically chain to configuration. This ensures required arguments are filled out.
+			ArgumentConfiguration ac = new ArgumentConfiguration(new_plugin);
 			if(ac.display()) {
-			    assigned.refresh();
+			    assignPlugIn(new_plugin);
+			    plugin_list.setSelectedValue(new_plugin, true);
 			}
-		    }
-		}
-	    }
-	}
-	/** A special list renderer which is able to render separating lines as well. */
-	private class ListRenderer
-	    extends DefaultListCellRenderer {
-				/** Return a component that has been configured to display the specified value. That component's paint method is then called to "render" the cell. If it is necessary to compute the dimensions of a list because the list cells do not have a fixed size, this method is called to generate a component on which getPreferredSize  can be invoked.
-				 * @param list - The <strong>JList</strong> we're painting.
-				 * @param value - The value returned by list.getModel().getElementAt(index) as an <strong>Object</strong>.
-				 * @param index - The cells index as an <i>int</i>.
-				 * @param isSelected - <i>true</i> if the specified cell was selected.
-				 * @param cellHasFocus - <i>true</i> if the specified cell has the focus.
-				 * @return A <strong>Component</strong> whose paint() method will render the specified value.
-				 * @see javax.swing.JList
-				 * @see javax.swing.JSeparator
-				 * @see javax.swing.ListModel
-				 * @see javax.swing.ListSelectionModel
-				 */
-	    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
-		if(value instanceof JPanel) {
-		    return (JPanel) value;
-		}
-		else {
-		    return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
-		}
-	    }
-	}
+			ac = null;
+			new_plugin = null;
+			plugin.setSelectedIndex(0);
+		    }
+		    else {
+			JOptionPane.showMessageDialog(Gatherer.g_man, get("PlugIn_Exists"), get("General.Error"), JOptionPane.ERROR_MESSAGE);
+		    }
+		}
+	    }
+	}
+
 	/** Listens for double clicks apon the list and react as if the configure button was pushed. */
 	private class ClickListener
 	    extends MouseAdapter {
-				/** Called whenever the mouse is clicked over a registered component, we use this to chain through to the configure prompt. 
-				 * @param event A <strong>MouseEvent</strong> containing information about the mouse click.
-				 */
+	    /** Called whenever the mouse is clicked over a registered component, we use this to chain through to the configure prompt. 
+	     * @param event A <strong>MouseEvent</strong> containing information about the mouse click.
+	    */
 	    public void mouseClicked(MouseEvent event) {
 		if(event.getClickCount() == 2 ) {
 		    if(!plugin_list.isSelectionEmpty()) {
-			Object object = plugin_list.getSelectedValue();
-			if(object instanceof PlugIn) {
-			    ArgumentConfiguration ac = new ArgumentConfiguration(gatherer, manager, (PlugIn)object);
+			PlugIn plugin = (PlugIn) plugin_list.getSelectedValue();
+			if(!plugin.isSeparator()) {
+			    ArgumentConfiguration ac = new ArgumentConfiguration(plugin);
 			    if(ac.display()) {
-				assigned.refresh();
+				refresh(plugin);
 			    }
+			    ac.destroy();
+			    ac = null;
 			}
+		    }
+		}
+	    }
+	}
+
+	/** This class listens for actions upon the configure button in the controls, and if detected creates a new <strong>ArgumentConfiguration</strong> dialog box to allow for configuration.
+	 * @see org.greenstone.gatherer.cdm.ArgumentConfiguration
+	 */
+	private class ConfigureListener
+	    implements ActionListener {
+	    /** Any implementation of <i>ActionListener</i> must include this method so that we can be informed when an action has occured on one of our target controls.
+	     * @param event An <strong>ActionEvent</strong> containing information garnered from the control action.
+	     */
+	    public void actionPerformed(ActionEvent event) {
+		if(!plugin_list.isSelectionEmpty()) {
+		    PlugIn plugin = (PlugIn) plugin_list.getSelectedValue();
+		    if(!plugin.isSeparator()) {
+			ArgumentConfiguration ac = new ArgumentConfiguration(plugin);
+			if(ac.display()) {
+			    refresh(plugin);
+			}
+			ac.destroy();
+			ac = null;
 		    }
 		}
@@ -946,4 +840,31 @@
 	    }
 	}
+
+	/** A special list renderer which is able to render separating lines as well. */
+	private class ListRenderer
+	    extends DefaultListCellRenderer {
+	    /** Return a component that has been configured to display the specified value. That component's paint method is then called to "render" the cell. If it is necessary to compute the dimensions of a list because the list cells do not have a fixed size, this method is called to generate a component on which getPreferredSize  can be invoked.
+	     * @param list - The <strong>JList</strong> we're painting.
+	     * @param value - The value returned by list.getModel().getElementAt(index) as an <strong>Object</strong>.
+	     * @param index - The cells index as an <i>int</i>.
+	     * @param isSelected - <i>true</i> if the specified cell was selected.
+	     * @param cellHasFocus - <i>true</i> if the specified cell has the focus.
+	     * @return A <strong>Component</strong> whose paint() method will render the specified value.
+	     * @see javax.swing.JList
+	     * @see javax.swing.JSeparator
+	     * @see javax.swing.ListModel
+	     * @see javax.swing.ListSelectionModel
+	     */
+	    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
+		PlugIn plugin = (PlugIn) value;
+		if(plugin.isSeparator()) {
+		    return separator;
+		}
+		else {
+		    return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
+		}
+	    }
+	}
+
 
 	/** Listens for actions apon the move buttons in the manager controls, and if detected calls the <i>movePlugIn()</i> method of the manager with the appropriate details. */
@@ -999,6 +920,6 @@
     }
     /** Creates a list separator.
-	  * Code courtesy of Farwell, Paul. Contact <a href="mailto:PFarwell@Kronos.com">PFarwell@Kronos.com</a>
-	  */
+     * Code courtesy of Farwell, Paul. Contact <a href="mailto:PFarwell@Kronos.com">PFarwell@Kronos.com</a>
+     */
     static private JPanel getSeparator() {
 	// we put the separator inside a panel to control
@@ -1014,6 +935,2 @@
     }
 }
-
-
-
-
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/Subcollection.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/Subcollection.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/Subcollection.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,209 +25,233 @@
  *########################################################################
  */
-
- 
-
-
-
-
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Copyright:    Copyright (c) 2001
- * Company:      The University of Waikato
  * Written:      03/05/02
  * Revised:      17/11/02 - Commenting
+ *               04/07/03 - Completely rewritten to support DOM
  **************************************************************************************/
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.cdm.DOMProxyListEntry;
+import org.greenstone.gatherer.msm.ElementWrapper;
 import org.greenstone.gatherer.msm.MSMUtils;
-import org.w3c.dom.Element;
+import org.greenstone.gatherer.util.StaticStrings;
+import org.greenstone.gatherer.util.Troolean;
+import org.w3c.dom.*;
 /** This class encapsulates one subcollection entry in the collection configuration file.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
- * @version 2.3
+ * @version 2.4
  */
 public class Subcollection
-    implements Comparable {
+    implements Comparable, DOMProxyListEntry {
     /** A <i>boolean</i> which is <i>true</i> if the condition is an include one, <i>false</i> otherwise. */
-    private boolean include = true;
-    /** Either the fully qualified name of the metadata whose value should be matched against the given expression, or <i>null</i> if you wish to match against the file name. */
-    private String element = null;
-    /** A String containing a Perl expression which is used as the filter for this subcollection. */
-    private String exp = null;
+    private Troolean include = new Troolean();
+    /** The DOM Element this Subcollection is based upon. */
+    private Element element = null;
+    /** A String containing a Perl expression which is used as the pattern by which to filter this subcollection. */
+    private String pattern = null;
     /** A series of flags to be used when matching the expression. */
     private String flags = null;
     /** A String which is a unique identifier of a subcollection. */
     private String name = null;
-    /** Constructor.
-     * @param name A <strong>String</strong> which is a unique identifier of a subcollection.
-     * @param pattern A <strong>String</strong> containing the inclusion, the element to filter, a Perl expression which is used as the filter for this subcollection, and a series of argument flags.
-     */
-    public Subcollection(String name, String pattern) {
+    /** Either the fully qualified name of the metadata whose value should be matched against the given expression, or <i>null</i> if you wish to match against the file name. */
+    private String source = null;
+    private String text = null;
+
+    /** Default constructor which should only be used during DOMProxyListModel initialization. */
+    public Subcollection() {
+    }
+
+    /** Constructor for representing an existing assigned Subcollection.
+     * @param element the Element this subcollection is based upon
+     */
+    public Subcollection(Element element) {
+	this.element = element;
+    }
+
+    /** Constructor for assigning a brand new Subcollection.
+     * @param name a unique identifier for this collection as a String
+     * @param include true if this the pattern should be an inclusion filter, false for exclusion
+     * @param source either the fully qualified name of an element as a String, or null to filter filenames
+     * @param pattern the matching pattern as a String
+     * @param flags any flags to use while matching, as a String
+     */
+    public Subcollection(String name, boolean include, String source, String pattern, String flags) {
+	// Cache the details
+	this.flags = flags;
+	this.include.set(include);
 	this.name = name;
-	// Have to do some work on pattern.
-	// Remove quote marks.
-	if(pattern.startsWith("\"") || pattern.startsWith("'")) {
-	    pattern = pattern.substring(1, pattern.length() - 1);
-	}
-	// Test for exclusion
-	if(pattern.startsWith("!")) {
-	    this.include = false;
-	    pattern = pattern.substring(1, pattern.length());
+	this.pattern = pattern;
+	if(source != null) {
+	    this.source = source;
 	}
 	else {
-	    this.include = true;
-	}
-	if(pattern.indexOf("/") != -1) {
-				// Now element (which may be Filename)
-	    this.element = pattern.substring(0, pattern.indexOf("/"));
-	    if(this.element.toLowerCase().equals("filename")) {
-		this.element = null;
+	    this.source = StaticStrings.FILENAME_STR;
+	}
+	// Create a new DOM Element with the appropriate attributes and text value
+	element = CollectionDesignManager.collect_config.document.createElement(StaticStrings.SUBCOLLECTION_ELEMENT);
+	element.setAttribute(StaticStrings.CONTENT_ATTRIBUTE, source);
+	element.setAttribute(StaticStrings.NAME_ATTRIBUTE, name);
+	element.setAttribute(StaticStrings.OPTIONS_ATTRIBUTE, flags);
+	element.setAttribute(StaticStrings.TYPE_ATTRIBUTE, (include ? StaticStrings.INCLUDE_STR : StaticStrings.EXCLUDE_STR));
+	MSMUtils.setValue(element, pattern);
+    }
+
+    /** Method to compare two subcollections.
+     * @param object he other subcollection to compare to, as an Object
+     * @return an int which is &gt;0, 0, or &lt;0 if this subcollection is before, equal to, or after the target object respectively.
+     */
+    public int compareTo(Object object) {
+	return getName().compareTo(((Subcollection)object).getName());
+    }
+
+    public DOMProxyListEntry create(Element element) {
+	return new Subcollection(element);
+    }
+
+    /** Method to check two subcollections for equality.
+     * @param object the other subcollection to compare to, as an Object
+     * @return true if the subcollections are equal, false otherwise.
+     */
+    public boolean equals(Object object) {
+	return (compareTo(object) == 0);
+    }
+
+    /** Retrieve the DOM Element this Subcollection is based upon.
+     * @return an Element
+     */
+    public Element getElement() {
+	return element;
+    }
+
+    /** Method to get the value of flags.
+     * @return the value of flags as a String
+     */
+    public String getFlags() {
+	if(flags == null && element != null) {
+	    flags = element.getAttribute(StaticStrings.OPTIONS_ATTRIBUTE);
+	}
+	return flags;
+    }
+
+    /** Method to get the value of name.
+     * @param String The value of name as a <strong>String</string>.
+     */
+    public String getName() {
+	if(name == null && element != null) {
+	    name = element.getAttribute(StaticStrings.NAME_ATTRIBUTE);
+	}
+	return name;
+    }
+
+    public String getPattern() {
+	if(pattern == null && element != null) {
+	    pattern = MSMUtils.getValue(element);
+	}
+	return pattern;
+    }
+
+    /** Method to get the name of the source of the strings used in pattern matching.
+     * @return a String which is either the fully qualified name of a metadata element, or filename
+     */
+    public String getSource() {
+	if(source == null &&element != null) {
+	    source = element.getAttribute(StaticStrings.CONTENT_ATTRIBUTE);
+	    // If this is a MSM Element then retrieve the appropriate ElementWrapper and use the language specific name
+	    if(!source.equals(StaticStrings.FILENAME_STR)) {
+		ElementWrapper element_wrapper = Gatherer.c_man.getCollection().msm.getElement(source);
+		if(element_wrapper != null) {
+		    source = element_wrapper.toString();
+		}
 	    }
-				// Extract Perl expression
-	    if(pattern.indexOf("/") != pattern.lastIndexOf("/")) {
-		this.exp = pattern.substring(pattern.indexOf("/") + 1,
-					     pattern.lastIndexOf("/"));
-		this.flags = pattern.substring(pattern.lastIndexOf("/") + 1);
-	    }
-	    else {
-		this.exp = pattern.substring(pattern.indexOf("/") + 1);
-	    }
-	}
-	else {
-				// Hmmm. Well I don't know what this is but it isn't a proper subcollection definition. Can't really 'return null' or something. So I'll just not set include, element, exp and flag expressions.
-	}
-    }
-    /** Constructor.
-	  * @param name A <strong>String</strong> which is a unique identifier of a subcollection.
-	  * @param include A <i>boolean</i> which is <i>true</i> if the condition is an include one, <i>false</i> otherwise.
-	  * @param exp A <strong>String</strong> containing a Perl expression which is used as the filter for this subcollection.
-	  */
-    public Subcollection(String name, boolean include, String exp, String flags) {
-	this.element = null;
-	this.exp = exp;
-	this.flags = flags;
-	this.include = include;
-	this.name = name;
-    }
-    /** Constructor.
-	  * @param name A <strong>String</strong> which is a unique identifier of a subcollection.
-	  * @param include A <i>boolean</i> which is <i>true</i> if the condition is an include one, <i>false</i> otherwise.
-	  * @param element Either the fully qualified name of the metadata whose value should be matched against the given expression, or <i>null</i> if you wish to match against the file name.
-	  * @param exp A <strong>String</strong> containing a Perl expression which is used as the filter for this subcollection.
-	  * @param flags A <strong>String</strong> of flags to be taken into account when matching the expression.
-	  */
-    public Subcollection(String name, boolean include, String element, String exp, String flags) {
+	}
+	return source;
+    }
+
+    public boolean isAssigned() {
+	return (element != null && !element.getAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE).equals(CollectionConfiguration.FALSE_STR));
+    }
+
+    /** Method to get the value of include.
+     * @param boolean true if this is an inclusion filter, false otherwise
+     */
+    public boolean isInclusive() {
+	if(!include.isDecided() && element != null) {
+	    include.set(element.getAttribute(StaticStrings.TYPE_ATTRIBUTE).equals(StaticStrings.INCLUDE_STR));
+	}
+	return include.isTrue();
+    }
+
+    public void setAssigned(boolean assigned) {
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE, (assigned ? CollectionConfiguration.TRUE_STR : CollectionConfiguration.FALSE_STR));
+	}
+    }
+
+    public void setElement(Element element) {
 	this.element = element;
-	this.exp = exp;
-	this.flags = flags;
-	this.include = include;
-	this.name = name;
-    }
-    /** Method to compare two subcollections.
-	  * @param object The other subcollection to compare to, as an <strong>Object</strong>.
-	  * @return An <i>int</i> which is greater than, equal to or less than zero if the this object is before, equal to, or after the target object respectively.
-	  */
-    public int compareTo(Object object) {
-	Subcollection sub = (Subcollection) object;
-	return getName().compareTo(sub.getName());
-    }
-    /** Method to check two subcollections for equality.
-	  * @param object The other subcollection to compare to, as an <strong>Object</strong>.
-	  * @return A <i>boolean</i> which is <i>true</i> if the subcollections are equal, <i>false</i> otherwise.
-	  */
-    public boolean equals(Object object) {
-	if(compareTo(object) == 0) {
-	    return true;
-	}
-	return false;
-    }
-    /** Method to get the value of element.
-	  * @return The value of element as an <strong>String</strong>.
-	  */
-    public String getElement() {
-	return element;
-    }
-    /** Method to get the value of expression.
-	  * @return The value of exp as a <strong>String</strong>.
-	  */
-    public String getExpression() {
-	return exp;
-    }
-    /** Method to get the value of flags.
-	  * @return The value of flags as a <strong>String</strong>.
-	  */
-    public String getFlags() {
-	return flags;
-    }
-    /** Method to get the value of include.
-	  * @param boolean The value of include as a <i>boolean</i>.
-	  */
-    public boolean getInclude() {
-	return include;
-    }
-    /** Method to get the value of name.
-	  * @param String The value of name as a <strong>String</string>.
-	  */
-    public String getName() {
-	return name;
-    }
-    /** Method to get the name of the source of the strings used in pattern matching.
-	  * @return A <strong>String</strong> which is either the fully qualified name of a metadata element, or "Filename".
-	  */
-    public String getSource() {
-	if(element != null) {
-	    return element;
-	}
-	return "Filename";
-    }
+	include.reset();
+	flags = null;
+	name = null;
+	pattern = null;
+	source = null;
+	text = null;
+    }
+
+    public void setFlags(String new_flags) {
+	if(element != null) {
+	    // Change element
+	    element.setAttribute(StaticStrings.OPTIONS_ATTRIBUTE, new_flags);
+	    flags = new_flags;
+	    text = null;
+	}
+    }
+
+    public void setInclusive(boolean new_include) {
+	if(element != null) {
+	    // Change element
+	    element.setAttribute(StaticStrings.TYPE_ATTRIBUTE, (new_include ? StaticStrings.INCLUDE_STR : StaticStrings.EXCLUDE_STR));
+	    include.set(new_include);
+	    text = null;
+	}
+    }
+
+    public void setName(String new_name) {
+	if(element != null) {
+	    // Change element
+	    element.setAttribute(StaticStrings.NAME_ATTRIBUTE, new_name);
+	    name = new_name;
+	    text = null;
+	}
+    }
+
+    public void setPattern(String new_pattern) {
+	if(element != null) {
+	    // Change element
+	    MSMUtils.setValue(element, new_pattern);
+	    pattern = new_pattern;
+	    text = null;
+	}
+    }
+
+    public void setSource(String new_source) {
+	if(element != null) {
+	    // Change element
+	    element.setAttribute(StaticStrings.CONTENT_ATTRIBUTE, new_source);
+	    source = new_source;
+	    text = null;
+	}
+    }
+
     /** Method to display the contents of this class as it would appear in the collection configuration file.
-	  * @return A <strong>String</strong> which could be used as a subcollection entry in collect.cfg.
-	  */
+     * @return a String representing this subcollection
+     */
     public String toString() {
-	String text = "subcollection        ";
-	text = text + name + " ";
-	text = text + "\"";
-	if(!include) {
-	    text = text + "!";
-	}
-	if(element != null) {
-	    text = text + element;
-	}
-	else {
-	    text = text + "Filename";
-	}
-	text = text + "/";
-	text = text + exp;
-	text = text + "/";
-	if(flags != null) {
-	    text = text + flags;
-	}
-	text = text + "\"\n";
+	if(text == null && element != null) {
+	    text = CollectionConfiguration.toString(element, true);
+	}
 	return text;
     }
-
-    /** Update certain fields of this subcollection.
-	  * @param name A <strong>String</strong> which is a unique identifier of a subcollection.
-	  * @param source Either the fully qualified name of the metadata whose value should be matched against the given expression, or <i>null</i> if you wish to match against the file name.
-	  * @param exp A <strong>String</strong> containing a Perl expression which is used as the filter for this subcollection.
-	  * @param include A <i>boolean</i> which is <i>true</i> if the condition is an include one, <i>false</i> otherwise.
-	  * @param flags A <strong>String</strong> of flags to be taken into account when matching the expression.
-		*/
-    public void update(String name, String source, String exp, boolean include, String flags) {
-	this.name = name;
-	this.element = source;
-	this.exp = exp;
-	this.include = include;
-	this.flags = flags;
-    }
-
-    /** Method to update the name of a metadata element, if it changes.
-	  * @param old_name The current name of the element as a <strong>String</strong>.
-	  * @param new_name The new name of the element as a <strong>String</strong>.
-	  */
-    public void updateElement(String old_name, String new_name) {
-	if(element.equals(old_name)) {
-	    element = new_name;
-	}
-    }
 }
 
